/usr/sbin/build-openstack-debian-image is in openstack-debian-images 1.25.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 | #!/bin/sh
# Copyright:
# (c) 2013-2016, Thomas Goirand <zigo@debian.org>
# (c) 2015-2016, Bastian Blank
# License: Apache 2.0, see LICENSE.txt for details.
set -e
if [ "$UNSHARED" != true ] ; then
exec env UNSHARED=true unshare --mount --pid --fork --mount-proc "$0" "$@"
fi
LC_ALL=C
export LC_ALL
# Parse input parameters
usage() {
echo "Usage: $0 --release|-r <jessie|wheezy|stretch|buster|bullseye> [options]
Options are:
--minimal|-m
--azure|-az
--boot-manager|-bm <grub|syslinux> (default: grub)
--debootstrap-url|-u <debootstrap-mirror> (default: http://httpredir.debian.org/debian)
--sources.list-mirror|-s <source-list-mirror> (default: http://httpredir.debian.org/debian)
--extra-packages|-e <package>,<package>,...
--hook-script|-hs <hook-script>
--image-size|-is <image-size> (default: 2G)
--automatic-resize|-ar
--automatic-resize-space|-ars <suplementary-space> (default: 50M)
--login|-l <userlogin> (default: debian)
--password|-p <root-password> (dangerous option: avoid it if possible)
--boot-type|-bt <boot type> (default: mbr)
--architecture|-a <architecture> (default: amd64)
For more info: man $0"
exit 1
}
EXTRA=yes
AZURE=no
BOOTMANAGER=grub
BOOTTYPE=mbr
ARCH=amd64
for i in $@ ; do
case "${1}" in
"--extra-packages"|"-e")
if [ -z "${2}" ] ; then
echo "No parameter defining the extra packages"
usage
fi
EXTRA_PACKAGES=${2}
shift
shift
;;
"--debootstrap-url"|"-u")
if [ -z "${2}" ] ; then
echo "No parameter defining the debootstrap URL"
usage
fi
DEB_MIRROR=${2}
shift
shift
;;
"--minimal"|"-m")
EXTRA=no
shift
;;
"--azure"|"-az")
AZURE=yes
shift
;;
"--boot-manager"|"-bm")
if [ "${2}" != "grub" ] && [ "${2}" != "syslinux" ] ; then
echo "No recognized parameter defining the boot manager"
usage
fi
BOOTMANAGER=${2}
shift
shift
;;
"--boot-type"|"-bt")
if [ "${2}" != "mbr" ] && [ "${2}" != "uefi" ] ; then
echo "No recognized parameter defining the boot type"
usage
fi
BOOTTYPE=${2}
shift
shift
;;
"--architecture"|"-a")
if [ "${2}" != "amd64" ] && [ "${2}" != "arm64" ] ; then
echo "No recognized parameter defining the architecture (currently support amd64 and arm64)"
usage
fi
ARCH=${2}
shift
shift
;;
"--automatic-resize"|"-ar")
AUTOMATIC_RESIZE=yes
shift
;;
"--automatic-resize-space"|"-ars")
if [ -z "${2}" ] ; then
echo "No parameter defining the suplementary space"
usage
fi
AUTOMATIC_RESIZE_SPACE=${2}
shift
shift
;;
"--image-size"|"-is")
if [ -z "${2}" ] ; then
echo "No parameter defining the image size"
usage
fi
IMAGE_SIZE=${2}
shift
shift
;;
"--hook-script"|"-hs")
if [ -z "${2}" ] ; then
echo "No parameter defining the hook script"
usage
fi
if ! [ -x "${2}" ] ; then
echo "Hook script not executable"
fi
HOOK_SCRIPT=${2}
shift
shift
;;
"--sources.list-mirror"|"-s")
if [ -z "${2}" ] ; then
echo "No parameter defining the hook script"
usage
fi
SOURCE_LIST_MIRROR=${2}
shift
shift
;;
"--release"|"-r")
if [ "${2}" = "wheezy" ] || [ "${2}" = "jessie" ] || [ "${2}" = "stretch" ] || [ "${2}" = "buster" ] || [ "${2}" = "bullseye" ] ; then
RELEASE=${2}
shift
shift
else
echo "Release not recognized."
usage
fi
;;
"--login"|"-l")
if [ -z "${2}" ] ; then
echo "No parameter defining the user login"
usage
fi
USER_LOGIN=${2}
shift
shift
;;
"--password"|"-p")
if [ -z "${2}" ] ; then
echo "No parameter defining the root password"
fi
ROOT_PASSWORD=${2}
shift
shift
;;
"--output"|"-o")
if [ -z "${2}" ] ; then
echo "No output file specified"
fi
OUTPUT=${2}
shift
shift
;;
*)
;;
esac
done
if [ -z "${RELEASE}" ] ; then
echo "Release not recognized: please specify the -r parameter."
usage
fi
case "${RELEASE}" in
"wheezy")
RELEASE_NUM=7
;;
"jessie")
RELEASE_NUM=8
;;
"stretch")
RELEASE_NUM=9
;;
"buster")
RELEASE_NUM=10
;;
esac
if [ -z "${DEB_MIRROR}" ] ; then
DEB_MIRROR=http://httpredir.debian.org/debian
fi
if [ -z "${EXTRA_PACKAGES}" ] ; then
EXTRA_PACKAGES=bash-completion,joe,most,screen,less,vim,bzip2,nano
fi
if [ -z "${SOURCE_LIST_MIRROR}" ] ; then
SOURCE_LIST_MIRROR=http://httpredir.debian.org/debian
fi
if [ -z "${IMAGE_SIZE}" ] ; then
IMAGE_SIZE=2
fi
if [ -z "${AUTOMATIC_RESIZE_SPACE}" ] ; then
AUTOMATIC_RESIZE_SPACE=50
fi
if [ -z "${USER_LOGIN}" ] ; then
USER_LOGIN=debian
fi
if [ -z "${OUTPUT}" ] ; then
OUTPUT=debian-${RELEASE}-$(TZ=UTC date '+%Y%m%d%H%M')-${ARCH}
fi
if [ "${BOOTTYPE}" = "uefi" ] && [ "${BOOTMANAGER}" != "grub" ] ; then
echo "uefi boot type is only compatible with grub"
usage
fi
if [ "${ARCH}" = "arm64" ] ; then
if [ "${BOOTMANAGER}" != "grub" ] || [ "${BOOTTYPE}" != "uefi" ] ; then
echo "arm64 depends on using grub and uefi"
usage
fi
fi
CONSOLE=ttyS0
if [ "${ARCH}" = "arm64" ] ; then
CONSOLE=ttyAMA0
fi
if [ "${BOOTMANAGER}" = "grub" ] ; then
if [ "${BOOTTYPE}" = "uefi" ] ; then
BOOT_MGR_PKG="grub-efi-${ARCH}"
if [ "${ARCH}" = "arm64" ] ; then
GRUB_TARGET="arm64-efi"
else
GRUB_TARGET="x86_64-efi"
fi
else
BOOT_MGR_PKG="grub-pc"
GRUB_TARGET="i386-pc"
fi
else
BOOT_MGR_PKG="extlinux"
fi
NEEDED_PACKAGES=sudo,adduser,locales,${BOOT_MGR_PKG},openssh-server,euca2ools,file,kbd,aptitude,file
if [ "${RELEASE}" = "wheezy" ] ; then
# These are needed by cloud-init and friends, and since we don't want backports of them,
# but just normal packages from Wheezy, we resolve dependencies by hand, prior to using
# apt-get -t wheezy-backports install cloud-init cloud-utils cloud-initramfs-growroot
NEEDED_PACKAGES=${NEEDED_PACKAGES},python,python-paramiko,python-argparse,python-cheetah,python-configobj,python-oauth,python-software-properties,python-yaml,python-boto,python-prettytable,initramfs-tools,python-requests,acpid,acpi-support-base,ntp
else
if [ "${RELEASE}" = "jessie" ] ; then
NEEDED_PACKAGES=${NEEDED_PACKAGES},cloud-initramfs-growroot
fi
NEEDED_PACKAGES=${NEEDED_PACKAGES},cloud-init,cloud-utils,dbus,ntp,unscd
fi
# This is a workaround for python3-cryptography failing to install
if [ "${RELEASE_NUM}" -ge 9 ] ; then
NEEDED_PACKAGES=${NEEDED_PACKAGES},python3-cffi-backend
fi
if [ ${EXTRA} = "no" ] ; then
PKG_LIST=${NEEDED_PACKAGES}
else
PKG_LIST=${NEEDED_PACKAGES},${EXTRA_PACKAGES}
fi
if ! [ `whoami` = "root" ] ; then
echo "You have to be root to run this script"
exit 1
fi
FILE_NAME=debian-${RELEASE}-${RELEASE_NUM}.0.0-1-${ARCH}
RAW_NAME=${OUTPUT}.raw
QCOW2_NAME=${OUTPUT}.qcow2
rm -f ${RAW_NAME}
set -x
######################################
### Prepare the HDD (format, ext.) ###
######################################
PARTED=/sbin/parted
rm -f $RAW_NAME
qemu-img create ${RAW_NAME} ${IMAGE_SIZE}G
if [ "${BOOTTYPE}" = "mbr" ] ; then
${PARTED} -s ${RAW_NAME} mktable msdos
${PARTED} -s -a optimal ${RAW_NAME} mkpart primary ext4 1Mi 100%
${PARTED} -s ${RAW_NAME} set 1 boot on
install-mbr --force ${RAW_NAME}
RESULT_KPARTX=$(kpartx -asv ${RAW_NAME} 2>&1)
if echo "${RESULT_KPARTX}" | grep "^add map" ; then
LOOP_DEVICE=$(echo ${RESULT_KPARTX} | cut -d" " -f3)
LOOPRAW_DEVICE=${LOOP_DEVICE%p*}
echo "kpartx mounted using: ${LOOP_DEVICE} via ${LOOPRAW_DEVICE}"
else
echo "It seems kpartx didn't mount the image correctly: exiting."
exit 1
fi
else # uefi
${PARTED} -s ${RAW_NAME} mktable gpt
${PARTED} -s -a optimal ${RAW_NAME} mkpart ESP fat32 1Mi 101Mi
${PARTED} -s -a optimal ${RAW_NAME} -- mkpart ROOT ext4 102Mi -64s
${PARTED} -s ${RAW_NAME} set 1 esp on
RESULT_KPARTX=$(kpartx -asv ${RAW_NAME} 2>&1 | tail -1)
if echo "${RESULT_KPARTX}" | grep "^add map" ; then
LOOP_DEVICE=$(echo ${RESULT_KPARTX} | cut -d" " -f3)
LOOPRAW_DEVICE=${LOOP_DEVICE%p*}
echo "kpartx mounted using: ${LOOP_DEVICE} via ${LOOPRAW_DEVICE}"
else
echo "It seems kpartx didn't mount the image correctly: exiting."
exit 1
fi
LOOP_DEVICE_ESP=$(kpartx -asv ${RAW_NAME} 2>&1 | head -1 | cut -d" " -f3)
fi
cleanup(){
error=$?
[ ! -d "${MOUNT_DIR}" ] && return
if [ "$error" -gt 0 ]; then
echo
echo "Error $error"
else
echo "Finished."
fi
set +e
sync
chroot ${MOUNT_DIR} umount /proc || true
chroot ${MOUNT_DIR} umount /sys || true
chroot ${MOUNT_DIR} umount /dev || true
umount -l ${MOUNT_DIR}
rmdir ${MOUNT_DIR}
kpartx -d ${RAW_NAME}
exit $error
}
trap "cleanup" EXIT TERM INT
mkfs.ext4 /dev/mapper/${LOOP_DEVICE}
UUID=$(blkid -o value -s UUID /dev/mapper/${LOOP_DEVICE})
# No fsck because of X days without checks
tune2fs -i 0 /dev/mapper/${LOOP_DEVICE}
MOUNT_DIR=`mktemp -d -t build-debimg.XXXXXX`
mount /dev/mapper/${LOOP_DEVICE} ${MOUNT_DIR}
if [ "${BOOTTYPE}" = "uefi" ] ; then
mkfs.vfat /dev/mapper/${LOOP_DEVICE_ESP}
UUID_ESP=$(blkid -o value -s UUID /dev/mapper/${LOOP_DEVICE_ESP})
mkdir -p ${MOUNT_DIR}/boot/efi
mount /dev/mapper/${LOOP_DEVICE_ESP} ${MOUNT_DIR}/boot/efi
fi
debootstrap --verbose \
--include=${PKG_LIST} \
${RELEASE} ${MOUNT_DIR} ${DEB_MIRROR}
############################
### Customize the distro ###
############################
### Customize: access to the VM ###
# # # # # # # # # # # # # # # # # #
# Setup default root password to what has been set on the command line
if [ -n "${ROOT_PASSWORD}" ] ; then
chroot ${MOUNT_DIR} sh -c "echo root:${ROOT_PASSWORD} | chpasswd"
fi
# Add a default user which is used by cloud-init by default.
# This isn't needed for at least stretch and on, because cloud-init
# creates the user, and it's best to give users a choice to overwrite it.
if [ "${RELEASE}" = "wheezy" ] || [ "${RELEASE}" = "jessie" ] ; then
chroot ${MOUNT_DIR} adduser --gecos Cloud-init-user --disabled-password --quiet ${USER_LOGIN}
fi
# Adds the "debian" user to sudoers, since that is the way
# cloud-init grant access
mkdir -p ${MOUNT_DIR}/etc/sudoers.d
echo "${USER_LOGIN} ALL = NOPASSWD: ALL" >${MOUNT_DIR}/etc/sudoers.d/debian-cloud-init
chmod 0440 ${MOUNT_DIR}/etc/sudoers.d/debian-cloud-init
### Customize: misc stuff ###
# # # # # # # # # # # # # # #
# Setup fstab
echo "# /etc/fstab: static file system information.
UUID=${UUID} / ext4 errors=remount-ro 0 1
" > ${MOUNT_DIR}/etc/fstab
if [ "${BOOTTYPE}" = "uefi" ] ; then
echo "UUID=${UUID_ESP} /boot/efi vfat errors=remount-ro 0 0" >> ${MOUNT_DIR}/etc/fstab
fi
mount -t proc proc ${MOUNT_DIR}/proc
echo "# disable pc speaker
blacklist pcspkr" >${MOUNT_DIR}/etc/modprobe.d/blacklist.conf
# No clear for the tty1 console
if [ "${RELEASE}" = "wheezy" ] ; then
sed -i "s#1:2345:respawn:/sbin/getty 38400 tty1#1:2345:respawn:/sbin/getty --noclear 38400 tty1#" ${MOUNT_DIR}/etc/inittab
else
# XXX: the serial port on Microsoft Azure plattform can't cope with
# lots of data, keep this option disabled.
#echo ForwardToConsole=yes >> ${MOUNT_DIR}/etc/systemd/journald.conf
:
fi
# We do it *after* the debootstrap, as otherwise it fails with
# systemd-shim conflicting with systemd-sysv.
chroot ${MOUNT_DIR} apt-get install -y locales-all libpam-systemd
# Turn off console blanking which is *very* annoying
# and increase KEYBOARD_DELAY because it can be annoying
# over network.
# Note: /etc/kbd/config is gone away from Stretch, but
# we still need to fix it for previous Debian releases.
# In stretch and beyond, consoleblank=0 in the kernel
# command line should be enough (TODO: check for that fact).
if [ -e ${MOUNT_DIR}/etc/kbd/config ] ; then
sed -i s/^BLANK_TIME=.*/BLANK_TIME=0/ ${MOUNT_DIR}/etc/kbd/config
sed -i s/^POWERDOWN_TIME=.*/POWERDOWN_TIME=0/ ${MOUNT_DIR}/etc/kbd/config
sed -i 's/^[ \t#]KEYBOARD_DELAY=.*/KEYBOARD_DELAY=1000/' ${MOUNT_DIR}/etc/kbd/config
fi
rm -f ${MOUNT_DIR}/etc/ssh/ssh_host_*
rm -f ${MOUNT_DIR}/etc/udev/rules.d/70-persistent-net.rules
rm -f ${MOUNT_DIR}/lib/udev/write_net_rules
# Setup networking (eg: DHCP by default)
echo "# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).
# The loopback network interface
auto lo
iface lo inet loopback
# The normal eth0
allow-hotplug eth0
iface eth0 inet dhcp
# Additional interfaces, just in case we're using
# multiple networks
allow-hotplug eth1
iface eth1 inet dhcp
allow-hotplug eth2
iface eth2 inet dhcp
# Set this one last, so that cloud-init or user can
# override defaults.
source /etc/network/interfaces.d/*
" > ${MOUNT_DIR}/etc/network/interfaces
# Setup the default hostname (will be set by cloud-init
# at boot time anyway)
echo "debian.example.com" >${MOUNT_DIR}/etc/hostname
# This should be a correct default everywhere
echo "deb ${SOURCE_LIST_MIRROR} ${RELEASE} main
deb-src ${SOURCE_LIST_MIRROR} ${RELEASE} main" >${MOUNT_DIR}/etc/apt/sources.list
if [ "${RELEASE}" != "sid" ] && [ "${RELEASE}" != "unstable" ] ; then
echo "deb ${SOURCE_LIST_MIRROR} ${RELEASE}-updates main
deb-src ${SOURCE_LIST_MIRROR} ${RELEASE}-updates main
deb http://security.debian.org/debian-security ${RELEASE}/updates main
deb-src http://security.debian.org/debian-security ${RELEASE}/updates main
" >>${MOUNT_DIR}/etc/apt/sources.list
fi
if [ "${RELEASE}" = "wheezy" ] ; then
echo "deb ${SOURCE_LIST_MIRROR} wheezy-backports main
deb-src ${SOURCE_LIST_MIRROR} wheezy-backports main
" >>${MOUNT_DIR}/etc/apt/sources.list
fi
if [ "${RELEASE}" = "jessie" ] && [ "${AZURE}" = "yes" ] ; then
echo "deb ${SOURCE_LIST_MIRROR} jessie-backports main
deb-src ${SOURCE_LIST_MIRROR} jessie-backports main
deb ${SOURCE_LIST_MIRROR}-azure jessie-backports main
deb-src ${SOURCE_LIST_MIRROR}-azure jessie-backports main
" >>${MOUNT_DIR}/etc/apt/sources.list
fi
if [ "${AZURE}" = "yes" ] ; then
chroot ${MOUNT_DIR} apt-key add - <<EOF
-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1
mQENBFYWcbkBCADKvo4KT/ic3wb4AoNFtWvoS1Ae3NFcvM/6WR/n9BTsayOlnjDu
EFh7yH16nIhuO5pZFocY+32BWMEmiK6/0pkk1lB9+XfNB8yqDCJ/ItzADfuKQv6g
smfx4tLa1Vj+jUbrgiIG7MYTCPlpkSuPA+FgntlR4JBxOy2g4fqqp3of+xM8tfSN
4I7/g1989YU9EQN53c1HGLdsc5x5Y5Kezd46H4IK5oyri7BaG4zRzpJLYa4yxB2W
re+HXP0a5SN/zQq1oq8pvkPubEBPKhdypZzzoHWPkZqXh1pHsMMNRkwsLW/3iwzE
IjDKrbdILz3/b+iLLIvYo9RlTycRO0XeS/B3ABEBAAG0UkRlYmlhbiBmb3IgQXp1
cmUgQXJjaGl2ZSBBdXRvbWF0aWMgU2lnbmluZyBLZXkgKDgvamVzc2llKSA8bWlj
cm9zb2Z0QGNyZWRhdGl2LmNvbT6JAT4EEwECACgFAlYWcbkCGwMFCQPCZwAGCwkI
BwMCBhUIAgkKCwQWAgMBAh4BAheAAAoJEAbqSemobK1/2c8H/1j4HK/izt7aw7Kk
g+ChRDhltb4LiYTZNgHaBnLGkKewkA1vYIHQjdu/pVnJjh1JzvOBFV+rhJ4Cc60D
s4JDqkrl8LpA4jsLb/PW1bRtbW92mPfhWgjyWs6S2tRBsBy1m2+SLZKeaDUq/PCD
VnaClzDh2fQYimI8IQk5U/u8VHXtDm3qYQSq7dJMTTnDcBC1oCjEYN+uPm9M+tUI
ik2hIE4VmjIXYTQVTa1lD+qyJvZ9hCsBUxAGllFpcWlyexN5orer6c+30XY/0Y4i
Q+zzVPrp1s6MgM9F8ofgd2+MhL57fwyj2A+Tbyzm7xYhzPPMx/mopo4pi884+5lo
FY6A20E=
=X0jG
-----END PGP PUBLIC KEY BLOCK-----
EOF
fi
chroot ${MOUNT_DIR} apt-get update
if [ "${AZURE}" = "yes" ] ; then
chroot ${MOUNT_DIR} apt-get install -y debian-azure-archive-keyring unscd
chroot ${MOUNT_DIR} apt-get update
fi
# Run dist-upgrade here - some security updates may involve installing
# packages with new names, like kernels with a new ABI chroot
chroot ${MOUNT_DIR} apt-get --no-install-recommends dist-upgrade -y
# Specifically remove all but the highest-versioned kernel
# image. Let's not waste space on older kernels we won't use...
OLD_KERNELS=$(COLUMNS=200 chroot ${MOUNT_DIR} dpkg -l | awk '/^ii linux-image-[0-9]/ {print $2}' | sort -u | head -n -1)
NUM_KERNELS=$(echo $OLD_KERNELS | wc -w)
if [ $NUM_KERNELS -gt 0 ]; then
echo "Removing old kernels: $OLD_KERNELS"
chroot ${MOUNT_DIR} apt-get remove --purge -y $OLD_KERNELS
fi
# And run autoremove to remove any dependencies that might have been
# brought in too
echo "Running apt-get autoremove:"
chroot ${MOUNT_DIR} apt-get autoremove -y
# Setup cloud-init, cloud-utils and cloud-initramfs-growroot
# These are only available from backports in Wheezy
if [ "${RELEASE}" = "wheezy" ] ; then
chroot ${MOUNT_DIR} apt-get -t wheezy-backports install cloud-init cloud-utils cloud-initramfs-growroot -y
cat > ${MOUNT_DIR}/etc/apt/preferences.d/linux.pref <<EOF
Package: linux-image-${ARCH} initramfs-tools
Pin: release n=wheezy-backports
Pin-Priority: 500
EOF
fi
chroot ${MOUNT_DIR} apt-get install -y linux-image-${ARCH}
if [ "${AZURE}" = "yes" ] ; then
echo "# to update this file, run dpkg-reconfigure cloud-init
datasource_list: [Azure]" >${MOUNT_DIR}/etc/cloud/cloud.cfg.d/90_dpkg.cfg
else
# DigitalOcean is available in cloud-init only starting on Jessie and on
# (ie: cloud-init >= 0.7.6)
if ! [ "${RELEASE}" = "wheezy" ] ; then
DIGITAL_OCEAN_SOURCE="DigitalOcean, "
else
DIGITAL_OCEAN_SOURCE=""
fi
echo "# to update this file, run dpkg-reconfigure cloud-init
datasource_list: [ NoCloud, AltCloud, ConfigDrive, OpenStack, CloudStack, ${DIGITAL_OCEAN_SOURCE} Ec2, MAAS, OVF, GCE, None ]" >${MOUNT_DIR}/etc/cloud/cloud.cfg.d/90_dpkg.cfg
fi
# Needed to have automatic mounts of /dev/vdb
echo "mount_default_fields: [~, ~, 'auto', 'defaults,nofail', '0', '2']" >>${MOUNT_DIR}/etc/cloud/cloud.cfg
echo "manage_etc_hosts: true" >>${MOUNT_DIR}/etc/cloud/cloud.cfg
# Set the cloud init default user (required for the keypair to be put in the right home directory)
sed -i "s/name: debian/name: ${USER_LOGIN}/" ${MOUNT_DIR}/etc/cloud/cloud.cfg
if [ "${AZURE}" = "yes" ] ; then
unshare --pid --fork --mount-proc chroot ${MOUNT_DIR} apt-get install -y waagent
rm -f ${MOUNT_DIR}/var/log/waagent.log
fi
# Setting-up initramfs
chroot ${MOUNT_DIR} update-initramfs -u
rm ${MOUNT_DIR}/var/cache/apt/archives/*.deb
# Set console for emergency and rescue shells
SYSTEMD_DIR="${MOUNT_DIR}/etc/systemd/system/"
for service in emergency.service rescue.service ; do
mkdir "${SYSTEMD_DIR}/${service}.d"
echo '[Service]
ExecStart=
ExecStart=-/bin/sh -c "/sbin/sulogin /dev/tty0; /bin/systemctl --fail --no-block default"' > "${SYSTEMD_DIR}/${service}.d/console.conf"
done
###################################
### Setting-up extlinux or grub ###
###################################
mkdir -p ${MOUNT_DIR}/boot/extlinux
if [ "${RELEASE}" = "wheezy" ] ; then
append="rootdelay=30"
fi
KERNEL_PARAMS="biosdevname=0 net.ifnames=0 console=tty0 console=$CONSOLE,115200 earlyprintk=$CONSOLE,115200 consoleblank=0 systemd.show_status=true $append"
if [ "${BOOTMANAGER}" = "grub" ] ; then
sed -i -e 's|^[ #\t]*GRUB_CMDLINE_LINUX_DEFAULT[ #\t]*=.*|GRUB_CMDLINE_LINUX_DEFAULT="'"${KERNEL_PARAMS}"'"|' ${MOUNT_DIR}/etc/default/grub
echo "
# openstack-debian-images disables OS prober to avoid
# loopback detection which breaks booting
GRUB_DISABLE_OS_PROBER=true" >>${MOUNT_DIR}/etc/default/grub
# Tell grub about our loopback devices first
mkdir -p ${MOUNT_DIR}/boot/grub
mount --bind /dev ${MOUNT_DIR}/dev
mount --bind /proc ${MOUNT_DIR}/proc
mount --bind /sys ${MOUNT_DIR}/sys
echo "grub-efi-${ARCH} grub2/force_efi_extra_removable boolean true" | chroot ${MOUNT_DIR} debconf-set-selections
chroot ${MOUNT_DIR} grub-mkconfig -o /boot/grub/grub.cfg
# Run grub from the chroot, pointing to the bind mounted /dev device.
chroot ${MOUNT_DIR} grub-install --target=${GRUB_TARGET} --no-nvram --force-extra-removable --no-floppy --modules="part_msdos part_gpt" --grub-mkdevicemap=/boot/grub/device.map /dev/${LOOPRAW_DEVICE}
# Run grub from the host, pointing to the guest installation
#grub-install --no-floppy --modules=part_msdos --grub-mkdevicemap=${MOUNT_DIR}/boot/grub/device.map --root-directory=${MOUNT_DIR} /dev/${LOOPRAW_DEVICE}
umount ${MOUNT_DIR}/sys
umount ${MOUNT_DIR}/dev
umount ${MOUNT_DIR}/proc
else
KERNEL_PARAMS="initrd=/initrd.img root=UUID=${UUID} ${KERNEL_PARAMS} ro"
echo "default linux
timeout 1
label linux
kernel /vmlinuz
append ${KERNEL_PARAMS}" > ${MOUNT_DIR}/boot/extlinux/extlinux.conf
extlinux --install ${MOUNT_DIR}/boot/extlinux
fi
###################
### HOOK SCRIPT ###
###################
if [ -x ${HOOK_SCRIPT} ] ; then
export BODI_CHROOT_PATH=${MOUNT_DIR}
export BODI_RELEASE=${RELEASE}
${HOOK_SCRIPT}
fi
##########################
### Unmount everything ###
##########################
cleanup(){
# refine cleanup everything was ok
echo "Finished."
}
sync
chroot ${MOUNT_DIR} umount /proc || true
chroot ${MOUNT_DIR} umount /sys || true
chroot ${MOUNT_DIR} umount /boot/efi || true
# Defrag the filesystem to allow for better size reduction below
e4defrag /dev/mapper/${LOOP_DEVICE} > /dev/null
umount ${MOUNT_DIR}
# Run FSCK so that resize can work
fsck.ext4 -f /dev/mapper/${LOOP_DEVICE} || true
if [ "${AUTOMATIC_RESIZE}" = "yes" ] ; then
resize2fs -M /dev/mapper/${LOOP_DEVICE}
FS_BLOCKS=`tune2fs -l /dev/mapper/${LOOP_DEVICE} | awk '/Block count/{print $3}'`
WANTED_SIZE=`expr $FS_BLOCKS '*' 4 '/' 1024 + ${AUTOMATIC_RESIZE_SPACE}` # Add ${AUTOMATIC_RESIZE_SPACE}M
resize2fs /dev/mapper/${LOOP_DEVICE} ${WANTED_SIZE}M
FINAL_FS_BLOCKS=`tune2fs -l /dev/mapper/${LOOP_DEVICE} | awk '/Block count/{print $3}'`
fi
sync
kpartx -d ${RAW_NAME}
rmdir ${MOUNT_DIR}
if [ "${AUTOMATIC_RESIZE}" = "yes" ] ; then
if [ "${BOOTTYPE}" = "mbr" ] ; then
# some blocks for mbr and multiple block size (4k)
FINAL_IMG_SIZE=`expr '(' $FINAL_FS_BLOCKS + 258 ')' '*' 4 '/' 1024`
# Rebuild a smaller partition table
${PARTED} -s ${RAW_NAME} rm 1
${PARTED} -s ${RAW_NAME} mkpart primary ext4 1Mi ${FINAL_IMG_SIZE}Mi
${PARTED} -s ${RAW_NAME} set 1 boot on
# Add 2M for the 1M at the beginning of the partition and some additional space
truncate -s `expr 3 + ${FINAL_IMG_SIZE}`M ${RAW_NAME}
install-mbr ${RAW_NAME}
else # uefi
# Work out the sizes of the new image
# 1M for the GPT header, and alignment padding
# 100M for the ESP
# $FINAL_FS_BLOCKS for the root partition
FINAL_IMG_SIZE=$((1 + 100 + $((${FINAL_FS_BLOCKS} * 4 / 1024)) + 1))
# Rebuild a smaller partition table
${PARTED} -s ${RAW_NAME} rm 2
${PARTED} -s -a optimal ${RAW_NAME} -- mkpart ROOT ext4 102Mi -64s
# Add 1M padding
truncate -s $((1 + ${FINAL_IMG_SIZE}))M ${RAW_NAME}
fi
fi
if ! [ "${AZURE}" = "yes" ] ; then
QEMU_VERSION=`qemu-img --help | head -n 1 | cut -d" " -f3 | cut -d"," -f1`
if dpkg --compare-versions ${QEMU_VERSION} gt 1.0 ; then
OTHER_QEMU_IMG_OPTIONS=" -o compat=0.10"
else
OTHER_QEMU_IMG_OPTIONS=""
fi
qemu-img convert -c -f raw ${RAW_NAME}${OTHER_QEMU_IMG_OPTIONS} -O qcow2 ${QCOW2_NAME}
fi
|